#!/usr/bin/env python
# -*- coding: utf-8 -*-

# Dev times :
#    15/11/2012 : 44 min 17 s
#    ---------------------------
#    Total :      44 min 17 s

import sys
import os.path
import httplib
import urllib
from PyQt4 import QtCore, QtGui
from PyQt4.QtCore import Qt
from PyQt4.QtGui import QMessageBox, QIcon

PASS_FILE = 'password.sav'

class Main(QtGui.QMainWindow):
    def __init__(self):
        QtGui.QMainWindow.__init__(self)
        self.setWindowTitle('Patton Connect')
        self.drawWidgets()
        
        if os.path.isfile(PASS_FILE):
            with open(PASS_FILE) as f:
                login, password = f.readline().strip().split(':')
                self.login.setText(login)
                self.password.setText(password)
    
    
    def drawWidgets(self):
        self.login = QtGui.QLineEdit()
        self.password = QtGui.QLineEdit()
        self.password.setEchoMode(QtGui.QLineEdit.Password)
        self.btn = QtGui.QPushButton('Connexion')
        self.btn.clicked.connect(self.btnConnect)
        
        form = QtGui.QFormLayout()
        form.addRow('Login', self.login)
        form.addRow('Mot de passe', self.password)
        form.addRow(self.btn)
        
        mainWidget = QtGui.QWidget()
        mainWidget.setLayout(form)
        
        self.setCentralWidget(mainWidget)


    def btnConnect(self):
        login, password = self.login.text(), self.password.text()
        with open(PASS_FILE, 'w+') as f:
            f.write('%s:%s' % (login, password))
        
        paramsString = urllib.urlencode({'action': 'authenticate',
                                         'login': login,
                                         'password': password,
                                         'policy_accept': 'true'})
        headers = {"Content-type": "application/x-www-form-urlencoded"}
        conn = httplib.HTTPSConnection('controller.mobile.lan')
        conn.request('POST', '/portal_api.php', paramsString, headers)
        res = conn.getresponse()
        data = res.read()

app = QtGui.QApplication(sys.argv)
window = Main()
window.show()
sys.exit(app.exec_())